//------------------------------------------------------
// module  : Denoise.h
// auteur  : Mignotte Max
// date    : 
// version : 1.0
// langage : C++
// labo    : DIRO
// note    : 
//------------------------------------------------------
//
//

#ifndef DENOISE_H
#define DENOISE_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionDec.h"
#include "Udwt.h"

//------------------------------------------------
// CLASSE Denoise  -------------------------------
//------------------------------------------------
class Denoise
 { 
 //---------- Donnees ---------
 //----------------------------
  public: 
  float**     Data;
  float**     Datafiltered;
  float**     DataWithoutNoise;
  float**     DataBest;
  float**     DataStop;
  
  float**     DataTmp1;
  float**     DataTmp2;
  float**     DataTmp3;
  float**     DataTmp4;
   
  //>Image
  int  length,width;

  //>Bruit
  float SigmaNoise;

  //>UDWT
  float Threshold_Udwt;
  int   NbLevels;

  //>Parametre Dec.
  float  StepLandweber;
  int    NbIterLandweber;

  //>Info
  char  NameImg[100];

  //>Flag
  int FlagSave;
  int FlagStop;

  //Best
  float MSE_Best;
  int   Iter_Best;
  float MSE_Stop;
  int   Iter_Stop;

  //Objet
  //-----
  Udwt*     udwt;

  
 //Fonctions --
 //------------
  public:  
  Denoise(float**,int,int);
   ~Denoise(); 

  //Options
  //-------
  void Options_UDWT(float,int);
  void Options(float**,float,char*,int,float);

  //Methode Deconvolution 
  //---------------------
  void NonLinearUdwtDeconvDenoising();
  
  //Methode Denoising
  //-----------------
  void Denoising_UDWT();

  //Mesures
  //-------
  float computeMMSE(float**,float**,int);

  //Gestion
  //-------
  void SauveGarde(float**,int,int); 
  void SauveGardeComment(float**,int,int,int);
};
//---------------------------------------------

#endif
