//------------------------------------------------------
// module  : FunctionDec.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionDec.h"

//--------------------------//
//-- Matrice de caractere --//
//--------------------------//
//----------------------------------------------------------
// alloue de la memoire pour une matrice 2d de caracteres
//----------------------------------------------------------
unsigned char** cmatrix_allocate_2d(int vsize,int hsize)
 {
  unsigned char** matrix;
  unsigned char* imptr;

  matrix=new unsigned char*[vsize];
  imptr=new unsigned char[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }
//----------------------------------------------------------
// libere la memoire de la matrice 2d de caracteres
//----------------------------------------------------------
void free_cmatrix_2d(unsigned char** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//--------------------------//
//-- Matrice de Flottant --//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }


//--------------//
// GESTION -----//
//--------------//
//----------------------------------------------------------
// copy_matrix
//----------------------------------------------------------
void copy_matrix(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   mat1[i][j]=mat2[i][j]; 
}

/*----------------------------------------------------------*/
/*  MeanSqImg                                               */
/*----------------------------------------------------------*/
float MeanSqImg(float** mat,int sz)
{
 int i,j;
 float mean=0.0;

 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
   mean+=mat[i][j];

 mean/=(CARRE(sz));

 return mean;
}

//----------------------------------------------------------
// AmplitudeSquareMatrix
//----------------------------------------------------------  
float AmplitudeSquareMatrix(float** img,int szimg)
{
 int i,j;
 float min,max;
 float moy;

 //Boucle
 moy=0.0;
 min=10000000000;
 max=-100000000;
 for(i=0;i<szimg;i++) for(j=0;j<szimg;j++) 
    { if (min>img[i][j]) min=img[i][j];
      if (max<img[i][j]) max=img[i][j]; }

 //Return
 return (max-min);
}

//--------------//
// BRUIT -------//
//--------------//
//----------------------------------------------------------
// retourne un nombre aleatoire entre zero et un
//----------------------------------------------------------
float randomize(void)
{ return ((float)rand()/RAND_MAX); }

//----------------------------------------------------------
//  bruit gaussien  
//----------------------------------------------------------
float gaussian_noise(float var,float mean)
{
 float noise,theta;

 //generation du bruit
 noise=sqrt(-2*var*log(1.0-((float)rand()/RAND_MAX)));
 theta=(float)rand()*1.9175345E-4-PI;
 noise=noise*cos(theta);
 noise+=mean;
 if (noise>GREY_LEVEL) noise=GREY_LEVEL;
 if (noise<0) noise=0;
 return noise;
}

//----------------------------------------------------------
//  bruit gaussien sur la matrice 
//----------------------------------------------------------
void add_gaussian_noise(float** mat,int lgth,int wdth,float var)
{
 int i,j;

 //Boucle sur l'image
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 if (var!=0.0) mat[i][j]=gaussian_noise(var,mat[i][j]);
}

//------------------------------------------------
// retourne un nombre aleatoire entre    
//         zero et un                    
//------------------------------------------------
float randomize2(void)
{ 
  return(genrand());
  //return ((float)rand()/RAND_MAX); 
}

static unsigned long mt[NN]; /* the array for the state vector  */
static int mti=NN+1; /* mti==N+1 means mt[N] is not initialized */

//----------------------------------------------------------
// sgenrand
//----------------------------------------------------------
/* initializing the array with a NONZERO seed */
void sgenrand(unsigned long seed)
{
  /* setting initial seeds to mt[N] using         */
  /* the generator Line 25 of Table 1 in          */
  /* [KNUTH 1981, The Art of Computer Programming */
  /*    Vol. 2 (2nd Ed.), pp102]                  */
  mt[0]= seed & 0xffffffff;
  for (mti=1; mti<NN; mti++)
    mt[mti] = (69069 * mt[mti-1]) & 0xffffffff;
}

//----------------------------------------------------------
// genrand
//----------------------------------------------------------
/* generating reals */
/* unsigned long */ /* for integer generation */
double genrand()
{
  unsigned long y;
  static unsigned long mag01[2]={0x0, MATRIX_A};
  /* mag01[x] = x * MATRIX_A  for x=0,1 */

  if (mti >= NN) { /* generate N words at one time */
    int kk;

    if (mti == NN+1)   /* if sgenrand() has not been called, */
      sgenrand(4357); /* a default initial seed is used   */

    for (kk=0;kk<NN-MM;kk++) {
      y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
      mt[kk] = mt[kk+MM] ^ (y >> 1) ^ mag01[y & 0x1];
    }
    for (;kk<NN-1;kk++) {
      y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
      mt[kk] = mt[kk+(MM-NN)] ^ (y >> 1) ^ mag01[y & 0x1];
    }
    y = (mt[NN-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
    mt[NN-1] = mt[MM-1] ^ (y >> 1) ^ mag01[y & 0x1];

    mti = 0;
  }
  
  y = mt[mti++];
  y ^= TEMPERING_SHIFT_U(y);
  y ^= TEMPERING_SHIFT_S(y) & TEMPERING_MASK_B;
  y ^= TEMPERING_SHIFT_T(y) & TEMPERING_MASK_C;
  y ^= TEMPERING_SHIFT_L(y);

  return ( (double)y / (unsigned long)0xffffffff ); /* reals */
  /* return y; */ /* for integer generation */
}

//--------------------//
//-- LOAD/SAVE/FILE --//
//--------------------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en pgm)             
//----------------------------------------------------------
void load_image_pgm(char* path,int** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char var;
  char header[100];
  char* ptr;
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".pgm")==NULL) strcat(path,".pgm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  tempc=fgets(header,100,fic);
  if ( (header[0]!=80) ||    /* 'P' */
       (header[1]!=53) ) {   /* '5' */
       fprintf(stderr,"Image %s is not PGM.\n",path);
       exit(1); }

  tempc=fgets(header,100,fic);
  while(header[0]=='#') tempc=fgets(header,100,fic);
 
  ta1=strtol(header,&ptr,0);
  ta2=atoi(ptr);
  tempc=fgets(header,100,fic);
  ta3=strtol(header,&ptr,0);
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    { temp=(int)fread(&var,1,1,fic);
      img[i][j]=(int)var; }

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en pgm)             
//----------------------------------------------------------
void load_image_pgm(char* path,float** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char var;
  char header[100];
  char* ptr;
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".pgm")==NULL) strcat(path,".pgm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  tempc=fgets(header,100,fic);
  if ( (header[0]!=80) ||    /* 'P' */
       (header[1]!=53) ) {   /* '5' */
       fprintf(stderr,"Image %s is not PGM.\n",path);
       exit(1); }

  tempc=fgets(header,100,fic);
  while(header[0]=='#') tempc=fgets(header,100,fic);
 
  ta1=strtol(header,&ptr,0);
  ta2=atoi(ptr);
  tempc=fgets(header,100,fic);
  ta3=strtol(header,&ptr,0);
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    { temp=(int)fread(&var,1,1,fic);
      img[i][j]=(int)var; }

  //fermeture du fichier
  fclose(fic);
 }


//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,int** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}


//----------------------//
//-- MATRIX OPERATION --//
//----------------------//
//------------------------------------------------------------------------------
// Moyenne 
//---------------------------------------------------------------------------------     
void ComputeMoy(float** mt,int length,int width)
{
  int i,j;
  float moy;

  //Calcul NRJ vraissemblance
  moy=0.0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) moy+=mt[i][j];
  moy/=(length*width);
 
  //Affiche
  //printf("  [Moy>%.3f]",moy);
}

//----------------------------------------------------------
// SubstractSquareMatrix
//----------------------------------------------------------
float SubstractSquareMatrix(float** matfres,float** mat1,float** mat2,int sz)
{
 int i,j;
 float NrjML;

 //Boucle
 NrjML=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  
    { matfres[i][j]=mat1[i][j]-mat2[i][j]; 
      NrjML+=CARRE(matfres[i][j]); }
 
 //Mesure
 NrjML/=(2*sz*sz);

 //Retour
 return NrjML;
}

//----------------------------------------------------------
// AddSquareMatrix
//----------------------------------------------------------
void AddSquareMatrix(float** matfres,float** mat1,float** mat2,float alp,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  
     matfres[i][j]=mat1[i][j]+alp*mat2[i][j]; 
}

//----------------------------------------------------------       
// ConstraintMaxMin 
//----------------------------------------------------------                
void ConstraintMaxMin(float** mat,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
    { if (mat[i][j]>255.0)  mat[i][j]=255.0;
      if (mat[i][j]<0.0)    mat[i][j]=0.0; } 
}

//----------------------------------------------------------       
// RecalSquareMatrix
//----------------------------------------------------------                
void RecalSquareMatrix(float** mat,float amp,int sz)
{
 int i,j;
 float max=-1000000.0;
 float min=1000000;

 for(i=0;i<sz;i++) for(j=0;j<sz;j++) if (mat[i][j]<min) min=mat[i][j];
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) if (mat[i][j]>max) max=mat[i][j];

 for(i=0;i<sz;i++) for(j=0;j<sz;j++) mat[i][j]*=amp/(max-min);

 max=-1000000.0;
 min=1000000;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) if (mat[i][j]<min) min=mat[i][j];
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) if (mat[i][j]>max) max=mat[i][j];
}

//----------------------------------------------------------       
// StabMatrix
//----------------------------------------------------------                
float StabMatrix(float** mat1,float** mat2,int sz)
{
 int i,j;
 float Nrj;
 float tmp;

 //Boucle
 Nrj=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) Nrj+=CARRE(mat1[i][j]-mat2[i][j]);

 tmp=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) tmp+=CARRE(mat1[i][j]);

 Nrj/=(tmp);

 //Retour
 return Nrj;
}


