//------------------------------------------------------
// module  : FunctionDec.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>

//------------------------------------------------
// CONSTANTES & DEFINITIONS ----------------------
//------------------------------------------------
#define CARRE(X) ((X)*(X))
#define PI  3.1415926535897
#define GREY_LEVEL 255

#define SWAP(a,b) temp=(a);(a)=(b);(b)=temp;

#define NB_BITS    8
#define BIT_CHAR   256
#define GREY_LEVEL 255
#define MIN(a,b)   (((a)>(b))?(b):(a))
#define MAX(a,b)   (((a)>(b))?(a):(b))

#define SQUARE(a)  ((a)*(a)) 

#define NN 624
#define MM 397
#define MATRIX_A 0x9908b0df   
#define UPPER_MASK 0x80000000 
#define LOWER_MASK 0x7fffffff 

#define TEMPERING_MASK_B 0x9d2c5680
#define TEMPERING_MASK_C 0xefc60000
#define TEMPERING_SHIFT_U(y)  (y >> 11)
#define TEMPERING_SHIFT_S(y)  (y << 7)
#define TEMPERING_SHIFT_T(y)  (y << 15)
#define TEMPERING_SHIFT_L(y)  (y >> 18)

//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------
unsigned char**  cmatrix_allocate_2d(int,int);
void             free_cmatrix_2d(unsigned char**);

float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);

int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);

void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);

void copy_matrix(float**,float**,int,int);
float MeanSqImg(float**,int);
float AmplitudeSquareMatrix(float**,int);

float randomize(void);
float gaussian_noise(float,float);
void  add_gaussian_noise(float**,int,int,float);

float  randomize2(void);
void   sgenrand(unsigned long seed);
double genrand();

//>>> Load/Save File
void GetLengthWidth(char*,int*,int*);
void load_image_pgm(char*,int**,int,int);
void load_image_pgm(char*,float**,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePgm(char*,char*,int**,int,int);

//>>> Matrix Operation
void ComputeMoy(float**,int,int);
float SubstractSquareMatrix(float**,float**,float**,int);
void AddSquareMatrix(float**,float**,float**,float,int);
void ConstraintMaxMin(float**,int);
void RecalSquareMatrix(float**,float,int);
float StabMatrix(float**,float**,int);
