//---------------------------------------------------
// module  : Udwt.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                 
//---------------------------------------------------
// 

#ifndef UDWT_H
#define UDWT_H

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include <stdio.h>
#include "FunctionDec.h"

//------------------------------------------------
// CLASSE HAAR -----------------------------------
//------------------------------------------------
class Udwt
{
 //-- Donnees --
 //-------------
 public:

 //Matrices
 float**  mat;
 float**  mat_rec;

 //Vecteur
 float*  vect;
 float*  vect_tmp;

 //Donnee
 int   FlagComment;
 int   width,length;
 int   Size,size;
 int   NbLevels;
 float Sigma2Noise;
 float Tau;

 //---------------
 //UDWT ----------
 //--------------
 float**  mat_udwt;
 float**  mat_udwt_dec;
 float**  mat_udwt_rec;

 float*   vect_udwt;
 float*   vect_udwt_dec;
 float*   vect_udwt_rec; 
 float*   vect_udwt_tmp;
 float*   vect_iudwt;
 float*   vect_iudwt_tmp;
 float*   vect_iudwt_tmp2;
 float**  tabvect_iudwt;
 int      nlev_udwt;
     
 //-- Methodes --
 //--------------
 public:
  Udwt(int,int);
  ~Udwt();

  //-------------------
  //-----UDWT----------
  //-------------------
  void UDWT_2D(int);
  void IUDWT_2D();
  void UDWT_1D_(float*,int);
  void IUDWT_1D_(float*,int);

  //--Denoising--
  void FilteringUDWT(float**,float,float,int);

  //Utile---------------
  void Haar1D_(float*,int);
  void HaarInv1D_(float*,int);
  void Decal(float*,int);
  void Recal(float*,int);
  void Copy(float*,float*,int);
  void Average(float*,float*,float*,int);
};

#endif 
